
#                   T H I S - I S - O B S O L E T E


# <BEGIN COPYRIGHT>
# This file is part of the "Bad Penguin" GNU/Linux distribution
# Copyright (C) 1997-98-99 by Antonio GALLO
# Author of this file: Antonio GALLO aka AGX
# Home Page at ......: http://www.badpenguin.org
# Home Page at ......: http://www.linux.it/~agx/
# e-mail contact ....: mailto:agx@linux.it	mailto:agx@geocities.com
# This program is distributed under the GNU General Public License
# You are not allowed to remove the copyright notice
# <END COPYRIGHT>
# 1.0.0 by agx@linux.it 


# Bad Penguin service body - Version 1.4.0 - 19990515


# --------------------------------------------------------
# Parameters
# --------------------------------------------------------
#	[start|stop|restart|reload]	[relaxed]
#	[configure]			[auto|manual|none]
#
#	start,			start the service
#	reload,			tell the service to reload his configuration
#	restart|force-reload,	stop and restart the service
#	stop			stop the service
#	query|status|probe	display the service status
#	relaxed			suppress error messages, and warning; used at boot time
#
#	configure		run the service configuration program
#	configure auto		run the service automatically at boot time
#	configure manual	the service is not started at boot time
#	configure none		the service will be locked and no one can start it		


# --------------------------------------------------------
# Exit codes
# --------------------------------------------------------
#	50 - executable not found
#	51 - prerequisite service not started
#	52 - problem with the configuration program
#	53 - service is disabled
#	60 - service is already started
#	61 - service is already stopped


# --------------------------------------------------------
# Query results
# --------------------------------------------------------
#	100	- started
#	200	- started but not running (Error)
#	101	- stopped
#	201	- stopped but running (Error)
#	102	- cannot query (Error)
#	202	- cannot query but it is running (Hacker warning!)


# <BEGIN COPYRIGHT>
# This file is part of "Bad Penguin"
# Copyright (C) 1997-98-99 by Antonio GALLO
# Author of this file: Antonio GALLO aka AGX
# Home Page at ......: http://www.badpenguin.org
# Home Page at ......: http://www.linux.it/~agx/
# e-mail contact ....: mailto:agx@linux.it	mailto:agx@geocities.com
# This program is distributed under the GNU General Public License
# You are not allowed to modify the file header or removing the copyright notice
# Modified by : <name> <web-site> <e-mail> <date> <list-of-changes>
# Modified by : <name> <web-site> <e-mail> <date> <list-of-changes>
# <END COPYRIGHT>



# -----------------------------------------------------------------

# Check if relaxed is specified
RELAXED=0
if [ "$2" = "relaxed" ]; then
	RELAXED=1
fi

case "$1" in

  start)
    echoc YELLOW "$SERVICE_NAME is using /etc/init.d/service-body.inc that is obsolete"
    is-executable-present 	"$SERVICE_BIN"			"$SERVICE_SUBSYS"
    if [ ! "$SERVICE_BIN2" = "" ]; then
	is-executable-present	"$SERVICE_BIN2"			"$SERVICE_SUBSYS"	"2"
    fi
    is-prerequisite-present 	"$SERVICE_PREREQ"
    is-service-configured	"$SERVICE_CONFIG"		"$SERVICE_SETUP"
    is-not-daemon-running	"$SERVICE_SUBSYS"		"$SERVICE_BIN"
    if [ ! "$SERVICE_BIN2" = "" ]; then
	is-not-daemon-running	"$SERVICE_BIN2"			"$SERVICE_SUBSYS"
    fi

    echoc GREEN -n "Starting $SERVICE_NAME "
    daemon "$SERVICE_BIN" $SERVICE_PARAMS
    REPLY=$?
        
    if [ $REPLY = 0 ]; then
      # Start the second binary
      if [ ! "$SERVICE_BIN2" = "" ]; then
        sleep 1
        daemon $SERVICE_BIN2 $SERVICE_PARAMS2
      fi
      # Set the flag file
      > /var/lock/subsys/$SERVICE_SUBSYS
      echo
    else
      echoc RED "problem starting service $SERVICE_NAME"
    fi
  ;;

# -----------------------------------------------------------------

  restart|reload|force-reload)
    if [ "$1" = "reload" -a "$SERVICE_RELOAD" = "YES" ]; then
      # Check if already running, exit only if relaxed is specified ...
      is-daemon-running "$SERVICE_SUBSYS" 	"$SERVICE_BIN"

      echoc GREEN -n "Reloading service $SERVICE_NAME "
      killHUP $SERVICE_BIN
      REPLY=$?
      #    
      if [ ! "$SERVICE_BIN2" = "" ]; then
        if [ ! "$SERVICE_RELOAD2" = "NO" ]; then
          sleep 1
          killHUP $SERVICE_BIN2
        fi
      fi
      #
      if [ $REPLY = 0 ]; then
        echo    
      else
        echoc RED "problem reloading the $SERVICE_NAME service"
      fi
      #
      exit 0
    fi
    
    # Default
    #is-daemon-running "$SERVICE_SUBSYS" 	"$SERVICE_BIN"
    echoc CYAN "Restarting service $SERVICE_NAME "
    $0 stop
    $0 start
    ;;

# -----------------------------------------------------------------  

  stop)
    #is-executable-present 	"$SERVICE_BIN"		"$SERVICE_SUBSYS"
    is-daemon-running 		"$SERVICE_SUBSYS" 	"$SERVICE_BIN"
    #is-service-configured	"$SERVICE_CONFIG"	"$SERVICE_SETUP"
    
    echoc GREEN -n "Stopping service $SERVICE_NAME "
    killproc $SERVICE_BIN
    REPLY=$?
    #
    if [ ! "$SERVICE_BIN2" = "" ]; then
      sleep 1
      killproc $SERVICE_BIN2
    fi
    #    
    if [ $REPLY = 0 ]; then
      rm -f /var/lock/subsys/$SERVICE_SUBSYS
      echo
    else
      echoc RED "problem stopping the $SERVICE_NAME service"
    fi
  ;;

# -----------------------------------------------------------------      

  query|status|probe)
    daemon-status	"$SERVICE_SUBSYS"	"$SERVICE_BIN"	"$SERVICE_CONFIG"
    ;;

# -----------------------------------------------------------------      

  configure)
    case $2 in
	auto*|AUTO*)
	    echoc GREEN The service $SERVICE_NAME will be started at boot time
	    echo "RUNME=AUTO" >> /etc/sysconfig/$PROFILE/$SERVICE_CONFIG
	    ;;
	manual*|MANUAL*)
	    echoc YELLOW The service $SERVICE_NAME can be started only manually
	    echo "RUNME=MANUAL" >> /etc/sysconfig/$PROFILE/$SERVICE_CONFIG	
	    ;;
	none|NONE|never|NEVER|lock|LOCK)
	    echoc YELLOW The service $SERVICE_NAME have been locked
	    echo "RUNME=NEVER" >> /etc/sysconfig/$PROFILE/$SERVICE_CONFIG		
	    ;;
	*)
    	    # Run the configuration program
	    if [ "$SERVICE_SETUP" = "" ]; then
		echoc RED "Service is not configurable !"
		exit 52
	    fi
	    if [ -x $SERVICE_SETUP ]; then
		exec $SERVICE_SETUP
		exit 52
	    else
		echoc RED "Cannot configure service, $SERVICE_SETUP is not an executable !"
		exit 52
	    fi
    	    ;;
    esac
    ;;
	
# -----------------------------------------------------------------      

  ""|relaxed)
    # Ignore errors
    ;;
    
  *)
    echoc RED "ERROR: calling $0 without any valid parameters"
    ;;

esac
#
